 function lambda_min = gersch(A)
 % The function GERSCH is used for finding the minimum eigenvalue
 % of the interval matrix family [A].
 %
 % LAMBDA_MIN = GERSCH(A) finds the minimum of the lambda. Function accepts 
 % input H as an interval matrix and returns minimum eigenvalue of A.
 %
 % Created by Andrea Szakalova on 2.3.2011
 
Habssup = sup(abs(A));
A_pom = Habssup-diag(diag(Habssup));

[n,m] = size(A);
for i=1:n
    A_dol = A(i,i).inf;
    lambda(i) = A_dol-sum(A_pom(i,:));
end
lambda_min = min(lambda);
 end
