function p = possymmat(A)

% possymmat(A) takes symmetric matrix (but not neccesarily symmetric) and
% returns vector p such that the matrix A+diag(p) is positive definite
%
% Radoslav Paulen and Andrea Szakalova, October 2011, STU in Bratislava, Slovakia 

n = length(A);
if sum(eig(A)<0) % if matrix A is not positive definite
   p = fmincon(@poseig,0.1*ones(n,1),[],[],[],[],zeros(n,1),Inf*ones(n,1),@poseig_con,optimset('display','off'),A);
else % if matrix A is positive definite
    p = zeros(n,1);
end

% minimize the norm of p
    function f = poseig(x,A)
        f = norm(x);
    end

% find p such that the matrix A+diag(p) is possitive definite
    function [c,ceq] = poseig_con(x,A)
        ceq = [];
        c = -eig(A+diag(x))+1e-6;  % value 
    end
end        