function alfa_i = sgm(A,d)
 % The Scaled Gerschgorin method allows the calculation of a different alfa
 % value for each variable.
 %
 % ALFA_I = SGM(A,d) will find a different alfa value. Function accepts input A
 % and input d, where [A] is a symmetric interval matrix and d is a vector. 
 %
 % Two choices of the vector d have been used to illustrative this alpha
 % calculation method:
 %
 % if n = 1 then d = 1 
 % if n = 2 then d = (xU- xL)
 %
 % Created by Andrea Szakalova on 16.10.2011

load A.mat
%nargin
Aabssup = sup(abs(A));
A_pom = Aabssup - diag(diag(Aabssup));
k = length(A(:,1));


if nargin==1   
   d = ones(k,1);
elseif nargin==2  
%        xU = [2,1];
%        xL = [-1,-1];
%     if length(xL)~=length(xU)
%        error('The vector d has not length as the number of rows of the symmetric interval matrix[A].')
%     end
%        d = (xU- xL);
%        d = d';  
end
        
[n] = length(A);
for i=1:n
    A_dol = A(i,i).inf;
    d(i) = d(i);
    alfa(i) = max(0,-1/2*(A_dol - (1/d(i))*(A_pom(i,:)*d))); 
end 
alfa_i = alfa;
end

