clc
clear
intvalinit('DisplayInfsup') % inicializacia INTLAB
global options 
options.optim = optimset('TolFun',1e-8,'TolX',1e-8,'MaxIter',1e4,'MaxFunEval',1e5,'GradObj','on','display','off','DerivativeCheck','off');  % volby pre optimalizaciu
options.optim2 = optimset('TolFun',1e-6,'TolX',1e-6','GradObj','on','display','off','DerivativeCheck','off');
presnost=1e-3; % nastavenie presnosti
MaxIter=10000;
k=[-2 2;-2 2]; % hranice pre premenne x=(x1 x2)=[x1L x1U;x2L x2U];
temp=cputime; % kvoli urceniu casu vypoctu

%%%%%%%%%%%%%%%SOLUTION%%%%%%%%%%%%%%%%%%

%%% 1.Initialization %%%%%
iteracia=0;  Ju=Inf;   L=[];        %list of subregions
for i=1:length(k(:,1)) % inicializacia R
    R(i,1)=infsup(k(i,1),k(i,end));
end

%%%% 2.Upper bound %%%%
A=[1 -1;-1 1]; B=[1;1];
[pR,J,exitflag]=fmincon(@objfun,R.mid,A,B,[],[],inf(R(:,1)),sup(R(:,1)),@confun,options.optim)
J
%[pR,J,exitflag]=fmincon(@objfun,R.mid,[],[],[],[],inf(R(:,1)),sup(R(:,1)),@confun,options.optim);
% [X,ucel_f,exitflag] = FMINCON(FUN,X0,A,B,Aeq,Beq,LB,UB,NONLCON,OPTIONS)
if exitflag>0
    Ju=J;
    p_opt=pR;
    UBound=Ju;
end

%%% 3.Lower bound %%%%
[pR,J,exitflag]=fmincon(@objfun2,R.mid,[],[],[],[],inf(R(:,1)),sup(R(:,1)),@confun2,options.optim2,R)
J
%[pR,J,exitflag]=fmincon(@objfun2,R.mid,[],[],[],[],inf(R(:,1)),sup(R(:,1)),@confun2,options.optim2,R);
if exitflag>0
    L.R=R;
    L.Jl=J;
    L.p_opt=pR;
    LBound=L.Jl;
end
er=2; JlR=-1e10; index_lbound=2; index_ubound=2;

while er>presnost
    %%% 4.Subregion selection %%%%
    if isempty(L)
        error('Problem is infeasible')
    end
    [JlR,b]=min(L.Jl);
    R=L.R(:,b);
    p_opt_LB=L.p_opt(:,b);
    L.R(:,b)=[];  L.Jl(b)=[];  L.p_opt(:,b)=[];
    
    %%% 5.Checking for convergence %%%%
    er=abs((Ju-JlR)/JlR);
    if er<=presnost
        cpu=cputime-temp %spytat sa na to
        p_opt
        Ju
        iteracia
        JlR
        p_opt_LB
    elseif iteracia==MaxIter
        p_opt
        Ju
        er
        error('Maximum number of iterations reached')
    else
        iteracia=iteracia+1;
        
        %%% 6.Branching within R %%%%
        [a,b]=max(R.rad);
        for i=1:length(R(:,1))
            if i==b
                R(b,1)=infsup(R(b,1).inf,R(b,1).inf+a);
                R(b,2)=infsup(R(b,1).sup,R(b,1).sup+a);
            else
                R(i,2)=R(i,1);
            end
        end
                
        %%% 7. Upper bound for each region %%%%
        [pRu(:,1),JuR(1),exitflag(1)]=fmincon(@objfun,R(:,1).mid,A,B,[],[],inf(R(:,1)),sup(R(:,1)),@confun,options.optim);
        [pRu(:,2),JuR(2),exitflag(2)]=fmincon(@objfun,R(:,2).mid,A,B,[],[],inf(R(:,2)),sup(R(:,2)),@confun,options.optim);
        JuR
        for i=1:2
            if exitflag(i)>0
                if JuR(i)<Ju
                    p_opt=pRu(:,i);
                    Ju=JuR(i);
                    UBound=[UBound;JuR(i)];
                end
            end
        end

        i=1;
        while i<=length(L.Jl)                   %%%% remove from L all subregions R for which JRL>Ju
                if L.Jl(i)>Ju
                    L.R(:,i)=[];
                    L.Jl(i)=[];
                    L.p_opt(:,i)=[];
                    i=i-1;
                end
                i=i+1;
        end
        
        %%% 8.Lower bound for each region %%%%
        [pRl(:,1),JlR(1),exitflag(1)]=fmincon(@objfun2,R(:,1).mid,[],[],[],[],inf(R(:,1)),sup(R(:,1)),@confun2,options.optim2,R(:,1));
        [pRl(:,2),JlR(2),exitflag(2)]=fmincon(@objfun2,R(:,2).mid,[],[],[],[],inf(R(:,2)),sup(R(:,2)),@confun2,options.optim2,R(:,2));
        JlR
%         pause
        for i=1:2
            if exitflag(i)>0
                if JlR(i)<=Ju
                    L.R(:,end+1)=R(:,i);  
                    L.Jl(end+1)=JlR(i);
                    L.p_opt(:,end+1)=pRl(:,i);
                    LBound=[LBound;JlR(i)];
                end
            end
        end
    end
end