 function lambda_min = e_matrix(A,n)
 % Function e-matrix using for the calculation of a lower bound on all the
 % eigenvalues of an interval matrix.
 % LAMBDA_MIN = E_MATRIX(A,n) attempts to find the minimum eigenvalue 
 % of the interval matrix family [A]. Function accepts input A and input n.  
 % vytvorena 9.3.2011

A_dol = A.inf;
deltaA = A.rad;
deltaA_modif = deltaA-diag(diag(deltaA));
A_midpoint = A.mid;
A_midpoint_modif = A_midpoint-diag(diag(A_midpoint))+diag(diag(A_dol));

if n==1
     E=0;
 elseif n==2
      E=diag(diag(deltaA));
end
lambda_min = min(eig(A_midpoint_modif+E))-max(abs(eig(deltaA_modif-abs(E))));
 end