 function lambda_min = lbh(A)
 % The lower bounding Hessian is a guaranteed lower bound on the minimum
 % eigenvalue of the interval matrix family.
 % LAMBDA_MIN = LBH(A) finds a minimum eigenvalue L to the matrix L. 
 % The real symmetric matrix L is a lower bounding Hessian of [A]. 
 % vytvorena 16.3.2011
 
A_dol = A.inf;
A_midpoint = A.mid;
LA_dol = diag(diag(A_dol));
AR_dol = -A.rad;
AR_nula = AR_dol-diag(diag(AR_dol));
LRS = diag(sum(AR_nula,2));
L1 = LA_dol+LRS;
L2 = A_midpoint-diag(diag(A_midpoint));
L = L1+L2;
lambda_min = min(eig(L));
 end