 function lambda_min = mori_kokame(A)
 % The function MORI_KOKAME is used for finding the minimum eigenvalue
 % of the interval matrix family [A] using the lower and upper vertex
 % matrices.
 %
 % LAMBDA_MIN = MORI_KOKAME(A) is difference the minimum of the eigenvalue 
 % of an  interval matrix [A_dol] and the spectral radius. The interval
 % matrix [A_dol] is a lower bound matrix [A].
 %
 % Created by Andrea Szakalova on 10.3.2011
 
A_dol = A.inf;
A_hor = A.sup;
lambda_min = min(eig(A_dol))-max(abs(eig(A_hor-A_dol)));
 end